Index: django/conf/locale/et/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/et/LC_MESSAGES/django.po	(revision 15755)
+++ django/conf/locale/et/LC_MESSAGES/django.po	(working copy)
@@ -5,8 +5,8 @@
 "Project-Id-Version: Django\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2011-02-28 17:34+0100\n"
-"PO-Revision-Date: 2011-02-22 00:09+0000\n"
-"Last-Translator: Jannis <jannis@leidel.info>\n"
+"PO-Revision-Date: 2011-03-04 21:26+0200\n"
+"Last-Translator: Erik Allik <eallik@gmail.com>\n"
 "Language-Team: Estonian <>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
@@ -28,7 +28,7 @@
 
 #: conf/global_settings.py:47
 msgid "Bosnian"
-msgstr ""
+msgstr "bosnia"
 
 #: conf/global_settings.py:48
 msgid "Catalan"
@@ -60,7 +60,7 @@
 
 #: conf/global_settings.py:55
 msgid "British English"
-msgstr ""
+msgstr "briti inglise"
 
 #: conf/global_settings.py:56
 msgid "Spanish"
@@ -68,12 +68,11 @@
 
 #: conf/global_settings.py:57
 msgid "Argentinian Spanish"
-msgstr ""
+msgstr "argentiina hispaani"
 
 #: conf/global_settings.py:58
-#, fuzzy
 msgid "Mexican Spanish"
-msgstr "hispaania"
+msgstr "mehhiko hispaania"
 
 #: conf/global_settings.py:59
 msgid "Estonian"
@@ -97,7 +96,7 @@
 
 #: conf/global_settings.py:64
 msgid "Frisian"
-msgstr ""
+msgstr "friisi"
 
 #: conf/global_settings.py:65
 msgid "Irish"
@@ -125,7 +124,7 @@
 
 #: conf/global_settings.py:71
 msgid "Indonesian"
-msgstr ""
+msgstr "indoneesi"
 
 #: conf/global_settings.py:72
 msgid "Icelandic"
@@ -169,11 +168,11 @@
 
 #: conf/global_settings.py:82
 msgid "Malayalam"
-msgstr ""
+msgstr "malaia"
 
 #: conf/global_settings.py:83
 msgid "Mongolian"
-msgstr ""
+msgstr "mongoolia"
 
 #: conf/global_settings.py:84
 msgid "Dutch"
@@ -185,15 +184,15 @@
 
 #: conf/global_settings.py:86
 msgid "Norwegian Bokmal"
-msgstr ""
+msgstr "norra (bokmal)"
 
 #: conf/global_settings.py:87
 msgid "Norwegian Nynorsk"
-msgstr ""
+msgstr "norra (nynorsk)"
 
 #: conf/global_settings.py:88
 msgid "Punjabi"
-msgstr ""
+msgstr "pandžab"
 
 #: conf/global_settings.py:89
 msgid "Polish"
@@ -225,7 +224,7 @@
 
 #: conf/global_settings.py:96
 msgid "Albanian"
-msgstr ""
+msgstr "albaania"
 
 #: conf/global_settings.py:97
 msgid "Serbian"
@@ -233,7 +232,7 @@
 
 #: conf/global_settings.py:98
 msgid "Serbian Latin"
-msgstr ""
+msgstr "serbia (ladina)"
 
 #: conf/global_settings.py:99
 msgid "Swedish"
@@ -261,11 +260,11 @@
 
 #: conf/global_settings.py:105
 msgid "Urdu"
-msgstr ""
+msgstr "urdu"
 
 #: conf/global_settings.py:106
 msgid "Vietnamese"
-msgstr ""
+msgstr "vietnami"
 
 #: conf/global_settings.py:107
 msgid "Simplified Chinese"
@@ -308,31 +307,31 @@
 #: core/validators.py:153
 #, python-format
 msgid "Ensure this value is %(limit_value)s (it is %(show_value)s)."
-msgstr ""
+msgstr "Veendu, et see väärtus on %(limit_value)s (hetkel on %(show_value)s)."
 
 #: core/validators.py:171 forms/fields.py:222 forms/fields.py:275
 #, python-format
 msgid "Ensure this value is less than or equal to %(limit_value)s."
-msgstr ""
+msgstr "Veendu, et see väärtus on väiksem või võrdne kui %(limit_value)s."
 
 #: core/validators.py:176 forms/fields.py:223 forms/fields.py:276
 #, python-format
 msgid "Ensure this value is greater than or equal to %(limit_value)s."
-msgstr ""
+msgstr "Veendu, et see väärtus on suurem või võrdne kui %(limit_value)s."
 
 #: core/validators.py:182
 #, python-format
 msgid ""
 "Ensure this value has at least %(limit_value)d characters (it has %"
 "(show_value)d)."
-msgstr ""
+msgstr "Veendu, et see väärtus sisaldab vähemalt %(limit_value)d tähte (hetkel on %(show_value)d)."
 
 #: core/validators.py:188
 #, python-format
 msgid ""
 "Ensure this value has at most %(limit_value)d characters (it has %"
 "(show_value)d)."
-msgstr ""
+msgstr "Veendu, et sellel väärtusel on mitte rohkem kui %(limit_value)d tähte (hetkel on %(show_value)d)."
 
 #: db/models/base.py:769
 #, python-format
@@ -351,7 +350,7 @@
 #: db/models/fields/__init__.py:63
 #, python-format
 msgid "Value %r is not a valid choice."
-msgstr ""
+msgstr "Väärtus %r ei ole korrektne."
 
 #: db/models/fields/__init__.py:64
 msgid "This field cannot be null."
@@ -359,12 +358,12 @@
 
 #: db/models/fields/__init__.py:65
 msgid "This field cannot be blank."
-msgstr ""
+msgstr "See lahter ei tohi olla tühi"
 
 #: db/models/fields/__init__.py:70
 #, python-format
 msgid "Field of type: %(field_type)s"
-msgstr ""
+msgstr "Lahter tüüpi: %(field_type)s"
 
 #: db/models/fields/__init__.py:451 db/models/fields/__init__.py:871
 #: db/models/fields/__init__.py:980 db/models/fields/__init__.py:991
@@ -404,7 +403,7 @@
 #: db/models/fields/__init__.py:589
 #, python-format
 msgid "Invalid date: %s"
-msgstr "Ebakorrektne kuupäev: %s"
+msgstr "Vigane kuupäev: %s"
 
 #: db/models/fields/__init__.py:670
 msgid "Enter a valid date/time in YYYY-MM-DD HH:MM[:ss[.uuuuuu]] format."
@@ -442,7 +441,7 @@
 
 #: db/models/fields/__init__.py:902
 msgid "Big (8 byte) integer"
-msgstr ""
+msgstr "Suur (8 baidine) täisarv"
 
 #: db/models/fields/__init__.py:915
 msgid "IP address"
@@ -479,19 +478,19 @@
 #: db/models/fields/related.py:815
 #, python-format
 msgid "Model %(model)s with pk %(pk)r does not exist."
-msgstr ""
+msgstr "Mudel %(model)s primaarvõtmega %(pk)r ei leidu."
 
 #: db/models/fields/related.py:817
 msgid "Foreign Key (type determined by related field)"
-msgstr ""
+msgstr "Välisvõti (tüübi määrab seotud väli) "
 
 #: db/models/fields/related.py:941
 msgid "One-to-one relationship"
-msgstr ""
+msgstr "Üks-ühele seos"
 
 #: db/models/fields/related.py:1003
 msgid "Many-to-many relationship"
-msgstr ""
+msgstr "Mitu-mitmele seos"
 
 #: db/models/fields/related.py:1023
 msgid ""
@@ -559,7 +558,7 @@
 
 #: forms/fields.py:464
 msgid "Please either submit a file or check the clear checkbox, not both."
-msgstr ""
+msgstr "Palun laadige fail või märgistage 'tühjenda' kast, mitte mõlemat."
 
 #: forms/fields.py:518
 msgid ""
@@ -602,7 +601,7 @@
 msgid ""
 "Please correct the duplicate data for %(field_name)s which must be unique "
 "for the %(lookup)s in %(date_field)s."
-msgstr ""
+msgstr "Please correct the duplicate data for %(field_name)s which must be unique for the %(lookup)s in %(date_field)s."
 
 #: forms/models.py:572
 msgid "Please correct the duplicate values below."
@@ -628,7 +627,7 @@
 
 #: forms/widgets.py:299
 msgid "Currently"
-msgstr ""
+msgstr "Hetkel"
 
 #: forms/widgets.py:300
 msgid "Change"
@@ -636,7 +635,7 @@
 
 #: forms/widgets.py:301
 msgid "Clear"
-msgstr ""
+msgstr "Tühjenda"
 
 #: forms/widgets.py:548
 msgid "Unknown"
@@ -664,27 +663,27 @@
 #: template/defaultfilters.py:802
 #, python-format
 msgid "%s KB"
-msgstr ""
+msgstr "%s kB"
 
 #: template/defaultfilters.py:804
 #, python-format
 msgid "%s MB"
-msgstr ""
+msgstr "%s MB"
 
 #: template/defaultfilters.py:806
 #, python-format
 msgid "%s GB"
-msgstr ""
+msgstr "%s GB"
 
 #: template/defaultfilters.py:808
 #, python-format
 msgid "%s TB"
-msgstr ""
+msgstr "%s TB"
 
 #: template/defaultfilters.py:809
 #, python-format
 msgid "%s PB"
-msgstr ""
+msgstr "%s PB"
 
 #: utils/dateformat.py:42
 msgid "p.m."
@@ -865,122 +864,122 @@
 #: utils/dates.py:31
 msgctxt "abbrev. month"
 msgid "Jan."
-msgstr ""
+msgstr "jaan."
 
 #: utils/dates.py:32
 msgctxt "abbrev. month"
 msgid "Feb."
-msgstr ""
+msgstr "veeb."
 
 #: utils/dates.py:33
 msgctxt "abbrev. month"
 msgid "March"
-msgstr ""
+msgstr "mär."
 
 #: utils/dates.py:34
 msgctxt "abbrev. month"
 msgid "April"
-msgstr ""
+msgstr "apr."
 
 #: utils/dates.py:35
 msgctxt "abbrev. month"
 msgid "May"
-msgstr ""
+msgstr "mai"
 
 #: utils/dates.py:36
 msgctxt "abbrev. month"
 msgid "June"
-msgstr ""
+msgstr "juuni"
 
 #: utils/dates.py:37
 msgctxt "abbrev. month"
 msgid "July"
-msgstr ""
+msgstr "juuli"
 
 #: utils/dates.py:38
 msgctxt "abbrev. month"
 msgid "Aug."
-msgstr ""
+msgstr "aug."
 
 #: utils/dates.py:39
 msgctxt "abbrev. month"
 msgid "Sept."
-msgstr ""
+msgstr "sept."
 
 #: utils/dates.py:40
 msgctxt "abbrev. month"
 msgid "Oct."
-msgstr ""
+msgstr "okt."
 
 #: utils/dates.py:41
 msgctxt "abbrev. month"
 msgid "Nov."
-msgstr ""
+msgstr "nov."
 
 #: utils/dates.py:42
 msgctxt "abbrev. month"
 msgid "Dec."
-msgstr ""
+msgstr "dets."
 
 #: utils/dates.py:45
 msgctxt "alt. month"
 msgid "January"
-msgstr ""
+msgstr "jaanuar"
 
 #: utils/dates.py:46
 msgctxt "alt. month"
 msgid "February"
-msgstr ""
+msgstr "veebruar"
 
 #: utils/dates.py:47
 msgctxt "alt. month"
 msgid "March"
-msgstr ""
+msgstr "märts"
 
 #: utils/dates.py:48
 msgctxt "alt. month"
 msgid "April"
-msgstr ""
+msgstr "aprill"
 
 #: utils/dates.py:49
 msgctxt "alt. month"
 msgid "May"
-msgstr ""
+msgstr "mai"
 
 #: utils/dates.py:50
 msgctxt "alt. month"
 msgid "June"
-msgstr ""
+msgstr "juuni"
 
 #: utils/dates.py:51
 msgctxt "alt. month"
 msgid "July"
-msgstr ""
+msgstr "juuli"
 
 #: utils/dates.py:52
 msgctxt "alt. month"
 msgid "August"
-msgstr ""
+msgstr "august"
 
 #: utils/dates.py:53
 msgctxt "alt. month"
 msgid "September"
-msgstr ""
+msgstr "september"
 
 #: utils/dates.py:54
 msgctxt "alt. month"
 msgid "October"
-msgstr ""
+msgstr "oktoober"
 
 #: utils/dates.py:55
 msgctxt "alt. month"
 msgid "November"
-msgstr ""
+msgstr "november"
 
 #: utils/dates.py:56
 msgctxt "alt. month"
 msgid "December"
-msgstr ""
+msgstr "detsember"
 
 #: utils/text.py:136
 msgid "or"
@@ -989,7 +988,7 @@
 #. Translators: This string is used as a separator between list elements
 #: utils/text.py:153
 msgid ", "
-msgstr ""
+msgstr ", "
 
 #: utils/timesince.py:21
 msgid "year"
@@ -1078,52 +1077,52 @@
 
 #: views/generic/dates.py:33
 msgid "No year specified"
-msgstr ""
+msgstr "Aasta on valimata"
 
 #: views/generic/dates.py:58
 msgid "No month specified"
-msgstr ""
+msgstr "Kuu on valimata"
 
 #: views/generic/dates.py:99
 msgid "No day specified"
-msgstr ""
+msgstr "Päev on valimata"
 
 #: views/generic/dates.py:138
 msgid "No week specified"
-msgstr ""
+msgstr "Nädal on valimata"
 
 #: views/generic/dates.py:198 views/generic/dates.py:214
-#, fuzzy, python-format
+#, python-format
 msgid "No %(verbose_name_plural)s available"
-msgstr "%(verbose_name)s kustutatud."
+msgstr "Ei leitud %(verbose_name_plural)s"
 
 #: views/generic/dates.py:466
 #, python-format
 msgid ""
 "Future %(verbose_name_plural)s not available because %(class_name)s."
 "allow_future is False."
-msgstr ""
+msgstr "Tulevane %(verbose_name_plural)s pole saadaval, sest %(class_name)s.allow_future on False."
 
 #: views/generic/dates.py:500
 #, python-format
 msgid "Invalid date string '%(datestr)s' given format '%(format)s'"
-msgstr ""
+msgstr "Vigane kuupäeva-string '%(datestr)s' lähtudes formaadist '%(format)s'"
 
 #: views/generic/detail.py:51
-#, fuzzy, python-format
+#, python-format
 msgid "No %(verbose_name)s found matching the query"
-msgstr "%(verbose_name)s edukalt muudetud."
+msgstr "Päringule vastavat %(verbose_name)s ei leitud"
 
 #: views/generic/list.py:47
 msgid "Page is not 'last', nor can it be converted to an int."
-msgstr ""
+msgstr "Lehekülg ei ole 'last', ka ei saa teda konvertida täisarvuks."
 
 #: views/generic/list.py:52
 #, python-format
 msgid "Invalid page (%(page_number)s)"
-msgstr ""
+msgstr "Vigane lehekülg (%(page_number)s)"
 
 #: views/generic/list.py:119
 #, python-format
 msgid "Empty list and '%(class_name)s.allow_empty' is False."
-msgstr ""
+msgstr "Tühi list ja '%(class_name)s.allow_empty' on False."